/**
 **   DiscWrapper - Cover designer for homemade discs.
 **   Copyright (C) 2008-2009  Nándor Mátravölgyi
 **
 **   This program is free software: you can redistribute it and/or modify
 **   it under the terms of the GNU General Public License as published by
 **   the Free Software Foundation, either version 3 of the License, or
 **   (at your option) any later version.
 **
 **   This program is distributed in the hope that it will be useful,
 **   but WITHOUT ANY WARRANTY; without even the implied warranty of
 **   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **   GNU General Public License for more details.
 **
 **   You should have received a copy of the GNU General Public License
 **   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **
 **   Contact:
 **   e-mail: nmatra@citromail.hu
 **
 **/
#ifndef ABOUTDIALOG_H
#define ABOUTDIALOG_H

#include "CommonFunctions.h"

//(*Headers(AboutDialog)
#include <wx/notebook.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/panel.h>
#include <wx/button.h>
#include <wx/dialog.h>
//*)
#include <wx/bitmap.h>
#include <wx/image.h>

class AboutDialog: public wxDialog
{
	public:

		AboutDialog(wxWindow* parent,wxWindowID id=wxID_ANY);
		virtual ~AboutDialog();

		//(*Declarations(AboutDialog)
		wxPanel* Panel5;
		wxNotebook* Notebook1;
		wxStaticText* StaticText2;
		wxPanel* Panel4;
		wxPanel* Panel1;
		wxStaticText* StaticText1;
		wxButton* Button2;
		wxPanel* Panel6;
		wxPanel* Panel3;
		wxTextCtrl* TextCtrl2;
		wxTextCtrl* TextCtrl1;
		wxPanel* Panel2;
		wxTextCtrl* TextCtrl3;
		//*)

	protected:

		//(*Identifiers(AboutDialog)
		static const long ID_PANEL6;
		static const long ID_STATICTEXT1;
		static const long ID_STATICTEXT2;
		static const long ID_PANEL2;
		static const long ID_TEXTCTRL3;
		static const long ID_PANEL3;
		static const long ID_TEXTCTRL1;
		static const long ID_PANEL4;
		static const long ID_TEXTCTRL2;
		static const long ID_PANEL5;
		static const long ID_NOTEBOOK1;
		static const long ID_BUTTON2;
		static const long ID_PANEL1;
		//*)

	private:

		//(*Handlers(AboutDialog)
		void OnCloseClick(wxCommandEvent& event);
		void OnLicenseClick(wxCommandEvent& event);
		void OnAppIconPaint(wxPaintEvent& event);
		void OnThanksToClick(wxCommandEvent& event);
		void OnTextCtrl2Text(wxCommandEvent& event);
		//*)

        wxBitmap AppIcon;

        CommonFunctions CFs;

		DECLARE_EVENT_TABLE()
};

#endif
