/**
 **   DiscWrapper - Cover designer for homemade discs.
 **   Copyright (C) 2008-2009  Nándor Mátravölgyi
 **
 **   This program is free software: you can redistribute it and/or modify
 **   it under the terms of the GNU General Public License as published by
 **   the Free Software Foundation, either version 3 of the License, or
 **   (at your option) any later version.
 **
 **   This program is distributed in the hope that it will be useful,
 **   but WITHOUT ANY WARRANTY; without even the implied warranty of
 **   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **   GNU General Public License for more details.
 **
 **   You should have received a copy of the GNU General Public License
 **   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **
 **   Contact:
 **   e-mail: nmatra@citromail.hu
 **
 **/

#ifndef COMMONFUNCTIONS_H
#define COMMONFUNCTIONS_H

//#include "DiscWrapperMain.h"

#include <wx/string.h>

class CommonFunctions
{
    //friend class DiscWrapperFrame;

    public:

        CommonFunctions();
        virtual ~CommonFunctions();

        wxString DataPath();
        void LocalDir();
        void DWLog(wxString ToLog);

        std::string wx2std(wxString s);
        wxString std2wx(std::string s);

        std::string oFolder_userM;  // Path of current user's home
        wxString PathCoordination;

        // Extra wxString functions
        wxString MyAfterFirst(wxString StringToWorkWith, wxString KeyString, int WantedLength, int place, int state);
        wxString MyBeforeFirst(wxString StringToWorkWith, wxString KeyString, int WantedLength, int place, int state);
        bool MyMatches(wxString StringToWorkWith, wxString KeyString, int place, int state);

};

#endif // DiscWrapperMAIN_H
