/**
 **   DiscWrapper - Cover designer for homemade discs.
 **   Copyright (C) 2008-2009  Nándor Mátravölgyi
 **
 **   This program is free software: you can redistribute it and/or modify
 **   it under the terms of the GNU General Public License as published by
 **   the Free Software Foundation, either version 3 of the License, or
 **   (at your option) any later version.
 **
 **   This program is distributed in the hope that it will be useful,
 **   but WITHOUT ANY WARRANTY; without even the implied warranty of
 **   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 **   GNU General Public License for more details.
 **
 **   You should have received a copy of the GNU General Public License
 **   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **
 **   Contact:
 **   e-mail: nmatra@citromail.hu
 **
 **/
#ifndef PREFERENCESDIALOG_H
#define PREFERENCESDIALOG_H

#include "CommonFunctions.h"

//(*Headers(PreferencesDialog)
#include <wx/checkbox.h>
#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/notebook.h>
#include <wx/button.h>
#include <wx/panel.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/choice.h>
//*)

class PreferencesDialog: public wxDialog
{
	public:

		PreferencesDialog(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~PreferencesDialog();

		//(*Declarations(PreferencesDialog)
		wxTextCtrl* TextCtrl3;
		wxPanel* Panel1;
		wxStaticText* StaticText13;
		wxButton* Button4;
		wxButton* Button1;
		wxCheckBox* CheckBox1;
		wxButton* Button2;
		wxButton* Button3;
		wxChoice* Choice2;
		wxStaticText* StaticText1;
		wxStaticText* StaticText10;
		wxPanel* Panel2;
		wxStaticText* StaticText3;
		wxPanel* Panel4;
		wxPanel* Panel5;
		wxChoice* Choice1;
		wxButton* Button5;
		wxCheckBox* CheckBox2;
		wxStaticText* StaticText12;
		wxTextCtrl* TextCtrl1;
		wxStaticText* StaticText4;
		wxStaticText* StaticText5;
		wxStaticText* StaticText2;
		wxNotebook* Notebook1;
		wxButton* Button7;
		wxTextCtrl* TextCtrl2;
		wxButton* Button6;
		wxStaticText* StaticText11;
		//*)

	protected:

		//(*Identifiers(PreferencesDialog)
		static const long ID_STATICTEXT1;
		static const long ID_STATICTEXT2;
		static const long ID_STATICTEXT3;
		static const long ID_CHOICE1;
		static const long ID_STATICTEXT5;
		static const long ID_CHECKBOX1;
		static const long ID_CHECKBOX2;
		static const long ID_STATICTEXT4;
		static const long ID_BUTTON1;
		static const long ID_BUTTON2;
		static const long ID_PANEL2;
		static const long ID_STATICTEXT11;
		static const long ID_TEXTCTRL1;
		static const long ID_BUTTON5;
		static const long ID_STATICTEXT12;
		static const long ID_TEXTCTRL2;
		static const long ID_BUTTON6;
		static const long ID_STATICTEXT13;
		static const long ID_TEXTCTRL3;
		static const long ID_BUTTON7;
		static const long ID_PANEL5;
		static const long ID_STATICTEXT10;
		static const long ID_CHOICE2;
		static const long ID_PANEL4;
		static const long ID_NOTEBOOK1;
		static const long ID_BUTTON3;
		static const long ID_BUTTON4;
		static const long ID_PANEL1;
		//*)

	private:

		//(*Handlers(PreferencesDialog)
		void OnClose(wxCommandEvent& event);
		void OnFont(wxCommandEvent& event);
		void OnColour(wxCommandEvent& event);
		void OnOK(wxCommandEvent& event);
		void OnBrowse1Click(wxCommandEvent& event);
		void OnBrowse2Click(wxCommandEvent& event);
		void OnBrowse3Click(wxCommandEvent& event);
		//*)

        wxFont PFont;       // Default font
        wxColour PColour;   // Default lolour
        int PClass;         // Default class of label

        CommonFunctions CFs;

		DECLARE_EVENT_TABLE()
};

#endif
